#!/bin/sh
# Run this to generate all the initial makefiles, etc.

AM_STRICTNESS="--gnu"

set -e

echo "** Processing..."

(grep "AM_GNU_GETTEXT" configure.in > /dev/null) && {
    echo "** It uses gettext, running gettextize..."
    echo "no" | gettextize --force > /dev/null
}

(grep "AM_PROG_LIBTOOL" configure.in > /dev/null) && {
    echo "** It uses libtool, running libtoolize..."
    libtoolize --force --automake > /dev/null
}

echo "** Running aclocal..."
aclocal $ACLOCAL_FLAGS

(grep "AM_CONFIG_HEADER" configure.in > /dev/null) && {
    echo "** It uses config header, running autoheader..."
    autoheader
}

# Just to avoid confusions.  Automake doesn't put ./configure into
# $(DISTFILES) if it's not found.
touch configure

echo "** Running automake..."
automake $STRICTNESS --add-missing

echo "** Running autoconf..."
autoconf

echo "** Running ./configure..."
./configure --enable-maintainer-mode --enable-compile-warnings=yes "$@"

echo "** Get ready.  Happy hacking."
