/* Baduki - Computer Baduk(Go) Program 
   Copyright(c) 1998-1999 Lim Jaebum <artist@soback.kornet21.net>

   This program is free software; you can redistribute it and'or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
   USA */

/* $Id: baduki.c,v 1.10 1999/03/20 00:52:02 artist Exp $ */ 

#include <config.h>
#include <stdio.h>
#include "intldefs.h"
#include <gtk/gtk.h>
#include "gtkgoboard.h"
#include "baduki.h"

char *playReason;

extern int playLevel, showTrees;

struct bRec goboard[19][19];
/*-- The main go board		--*/

struct String StringList[MAXSTRINGS];
/*-- The list of Strings		--*/
int DeletedStrings[4];
/*-- Codes of deleted strings	--*/

int StringCount = 0;
/*-- The total number of strings	--*/
int DeletedStringCount;
/*-- The total number of strings	--*/
/*-- deleted on a move		--*/
int ko, koX, koY;
int blackTerritory, whiteTerritory;
int Prisoners[2];
int current_score[2] = {0, 0};
int showMoveReason = TRUE, stringInfo = FALSE, whitePassed = FALSE, blackPassed = FALSE;

int current_move = 0;
int max_move = 0;
pointc move_log[400];
float dum = 0;
int board_size = 19;
int ignore_takecorner = FALSE;

void FillPoints(int x, int y, int val);

/* Arrays for use when checking around a point */
int xVec[4] =
{0, 1, 0, -1};
int yVec[4] =
{-1, 0, 1, 0};

int member(string, stringlist, cnt)
     int string;
     int stringlist[4];
     int cnt;
{
  unsigned int i;


  for (i = 0; i < cnt; i++)
    if (stringlist[i] == string)
      return TRUE;
  return FALSE;
}

/* Does a stone at x, y connect to any strings of color? */
int Connect(color, x, y, fStrings, fCnt, eStrings, eCnt)
     enum bVal color;
     int x, y;
     int fStrings[4], eStrings[4];
     int *fCnt, *eCnt;
{
  unsigned int point = 0;
  int tx, ty, total = 0;
  enum bVal opcolor = WHITE;


  *fCnt = 0;
  *eCnt = 0;
  if (color == WHITE)
    opcolor = BLACK;
  for (point = 0; point <= 3; point++) {
    tx = x + xVec[point];
    ty = y + yVec[point];
    if (!LegalPoint(tx, ty))
      continue;
    if (goboard[tx][ty].Val == color) {
      total++;
      if (!member(goboard[tx][ty].StringNum, fStrings, *fCnt))
	fStrings[(*fCnt)++] = goboard[tx][ty].StringNum;
    } else if (goboard[tx][ty].Val == opcolor) {
      total++;
      if (!member(goboard[tx][ty].StringNum, eStrings, *eCnt))
	eStrings[(*eCnt)++] = goboard[tx][ty].StringNum;
    }
  }
  return total;
}

/* Returns the maximum number of liberties for a given intersection */
int Maxlibs(x, y)
     int x, y;
{
  int cnt = 4;


  if (x == 0 || x == 18)
    cnt--;
  if (y == 0 || y == 18)
    cnt--;
  return cnt;
}

void bdk_mark_death_stone(int x, int y)
{
  if (goboard[x][y].Val != EMPTY)
    StringCapture(goboard[x][y].StringNum);
}

/* Determine whether x, y is suicide for color */
int Suicide(color, x, y)
     enum bVal color;
     int x, y;
{
  enum bVal opcolor = BLACK;
  int friendlycnt, friendlystrings[4], enemycnt, enemystrings[4], total;
  int maxlibs, i, libcnt = 0;


  if (color == BLACK)
    opcolor = WHITE;
  maxlibs = Maxlibs(x, y);
  total = Connect(color, x, y, friendlystrings, &friendlycnt,
      enemystrings, &enemycnt);

  /* : ⼭ libboard Ÿ  */

  if (total < maxlibs)
    return FALSE;

  /* Check for a capture */
  for (i = 0; i < enemycnt; i++)
    if (StringList[enemystrings[i]].liberties == 1)
      return FALSE;
  for (i = 0; i < friendlycnt; i++)
    libcnt += (StringList[friendlystrings[i]].liberties - 1);
  if (libcnt != 0)
    return FALSE;
  return TRUE;
}

/* Returns the number of liberties for x, y */
int StoneLibs(x, y)
     int x, y;
{
  int cnt = 0, tx, ty;
  unsigned int point;


  for (point = 0; point <= 3; point++) {
    tx = x + xVec[point];
    ty = y + yVec[point];
    if (LegalPoint(tx, ty) && goboard[tx][ty].Val == EMPTY)
      cnt++;
  }
  return cnt;
}

void EraseMarks()
{
  register int i;
  register struct bRec *gpt = &goboard[0][0];


  for (i = 0; i < 361; gpt++, i++)
    gpt->marked = FALSE;
}

/* Place a stone of color at x, y */
int bdk_place_stone(int color, int x, int y)
{
  int fstrings[4], estrings[4];	/* string codes surrounding stone */
  int fcnt, ecnt, i;
  int lowest = StringCount + 1;
  int new_move = TRUE;

  DeletedStringCount = 0;
  
  if (max_move > current_move && 
	(move_log[current_move].px == x && move_log[current_move].py == y))
    new_move = FALSE;

  /* -1϶  */
  if (x == -1 || y == -1) {
    move_log[current_move].px = x;
    move_log[current_move].py = y;
    move_log[current_move].color = color;
    current_move++;
    ko = FALSE;
    if (new_move)
      max_move = current_move;
    
    return TRUE;
  }

  if (goboard[x][y].Val != EMPTY || Suicide(color, x, y))
    return FALSE;

  if (ko && koX == x && koY == y)
    return FALSE;

  move_log[current_move].px = x;
  move_log[current_move].py = y;
  move_log[current_move].color = color;
  current_move++;
  if (new_move)
    max_move = current_move;
  
  ko = FALSE;
  placestone(color, x, y);
  goboard[x][y].Val = color;
  /* Does the new stone connect to any friendly stone(s)? */
  Connect(color, x, y, fstrings, &fcnt, estrings, &ecnt);
  if (fcnt) {
    /* Find the connecting friendly string with the lowest code */
    for (i = 0; i < fcnt; i++)
      if (fstrings[i] <= lowest)
	lowest = fstrings[i];
/*-- Renumber resulting string --*/
/*-- Raise the stone count of the lowest by one to account --*/
/*-- for new stone --*/
    goboard[x][y].StringNum = lowest;
    StringList[lowest].count++;
    for (i = 0; i < fcnt; i++)
      if (fstrings[i] != lowest)
	MergeStrings(lowest, fstrings[i]);
    /* Fix the liberties of the resulting string */
    CountLiberties(lowest);
  } else {
    /* Isolated stone.  Create new string. */
    StringCount++;
    lowest = StringCount;
    StringList[lowest].color = color;
    StringList[lowest].count = 1;
    StringList[lowest].internal = 0;
    StringList[lowest].external = StoneLibs(x, y);
    StringList[lowest].liberties = StringList[lowest].external;
    StringList[lowest].eyes = 0;
    StringList[lowest].alive = 0;
    StringList[lowest].territory = 0;
    goboard[x][y].StringNum = lowest;
  }
  /* Now fix the liberties of enemy strings adjacent to played stone */
  FixLibs(color, x, y, PLACED);	/* Fix the liberties of opcolor */
  ReEvalStrings(color, x, y, lowest);
  RelabelStrings();
  return TRUE;
}

void UndoLastMove()
{
  extern int current_handicap, current_turn, max_move;
  extern int last_x[2], last_y[2], player_type[2];
  extern int pass_count;
  extern GtkGoBoard *go_board;
  int i, old_move, old_max_move;
  
  if (current_move < 1)
    return;

  old_max_move = max_move;
  
  old_move = current_move - 1;
  
  if (old_move > 1 && player_type[NEXT_TURN] != TYPE_HUMAN) {
    old_move--;
  }
  
  gtk_go_board_clear_board(go_board);
  restart_baduk(current_handicap);
  
  for (i = 0; i < old_move; i++) {
    if (move_log[i].px < 0)
      pass_count++;
    else {
      pass_count = 0;
    }
    if (move_log[i].color == BLACK) {
      last_x[BLACK] = move_log[i].px + 1;
      last_y[BLACK] = move_log[i].py + 1;
    } else {
      last_x[WHITE] = move_log[i].px + 1;
      last_y[WHITE] = move_log[i].py + 1;
    }
    bdk_place_stone(move_log[i].color, move_log[i].px, move_log[i].py);
  }
  current_turn = !move_log[i-1].color;
  if (last_x[BLACK])
    gtk_go_board_set_mark(go_board, last_x[BLACK], last_y[BLACK], GTK_GO_BOARD_TR_MASK);
  if (last_x[WHITE])
    gtk_go_board_set_mark(go_board, last_x[WHITE], last_y[WHITE], GTK_GO_BOARD_TR_MASK);
  max_move = old_max_move;
  show_moveinfo();
}

void RedoNextMove()
{
  extern int current_turn;
  extern int pass_count;
  extern int last_x[2], last_y[2];
  extern GtkGoBoard *go_board;
  
  if (max_move <= current_move)
    return;
  
  current_turn = move_log[current_move].color;
  if (last_x[current_turn])
    gtk_go_board_set_mark(go_board,
    	last_x[current_turn], last_y[current_turn], 0);
  
  last_x[current_turn] = move_log[current_move].px + 1;
  last_y[current_turn] = move_log[current_move].py + 1;
  
  if (move_log[current_move].px == -1)
    pass_count++;
  else
    pass_count = 0;

  bdk_place_stone(current_turn, move_log[current_move].px,
  			move_log[current_move].py);

  if (last_x[current_turn])
    gtk_go_board_set_mark(go_board,
	last_x[current_turn], last_y[current_turn], GTK_GO_BOARD_TR_MASK);

  current_turn = NEXT_TURN;
  show_moveinfo();
}

/* Remove a stone from the board */
void GoRemoveStone(x, y)
     int x, y;
{
  goboard[x][y].Val = EMPTY;
  goboard[x][y].StringNum = 0;
  removestone(x, y);
}

/* Merges two strings -- Renumbers stones and deletes second string from
   list.  Fixes stone count of strings.  This does not fix anything else. 
   FixLibs must be called to fix liberties, etc. */
void MergeStrings(g1, g2)
     int g1, g2;
{
  int x, y;


  ForeachPoint(y, x)
      if (goboard[x][y].StringNum == g2)
    goboard[x][y].StringNum = g1;
  StringList[g1].count += StringList[g2].count;
  DeleteString(g2);		/* Removes string from StringList */
}

/* Stores a string code to be deleted */
void DeleteString(code)
     int code;
{
  DeletedStrings[DeletedStringCount++] = code;
}

/* Re-evaluate the strings given the last move.  This assumes that the
   last move has been merged into adjoining strings and all liberty counts
   are correct.  Handles capture. Checks for Ko.  Keeps track of captured
   stones. code is the string number of the stone just played. */
void ReEvalStrings(color, x, y, code)
     enum bVal color;
     int x, y, code;
{
  int fstrings[4], estrings[4], fcnt, ecnt, i, killcnt = 0, count = 0;
  enum bVal opcolor = BLACK;

  if (color == BLACK)
    opcolor = WHITE;
  /* Check for capture */
  Connect(color, x, y, fstrings, &fcnt, estrings, &ecnt);
  if (ecnt) {
    /* See if any of the strings have no liberties */
    for (i = 0; i < ecnt; i++)
      if (StringList[estrings[i]].liberties == 0) {
	killcnt++;
	count = StringList[estrings[i]].count;
	StringCapture(estrings[i]);
      }
  }
  /* Check for ko.  koX and koY are set in StringCapture above. */
  if (killcnt == 1 && count == 1 && StringList[code].count == 1
      && StringList[code].liberties == 1) {
    ko = TRUE;
  }
  if (killcnt)
    intrPrisonerReport(Prisoners[BLACK], Prisoners[WHITE]);
  /* Set eye count for strings */
  CountEyes();
}

/* Remove a captured string from the board and fix the liberties of any
   adjacent strings.  Fixes prisoner count. Sets KoX and KoY */
/*-- update display of captured stones -neilb --*/
void StringCapture(code)
     int code;
{
  int x, y;

  if (StringList[code].color == BLACK)
    Prisoners[BLACK] += StringList[code].count;
  else
    Prisoners[WHITE] += StringList[code].count;
  intrPrisonerReport(Prisoners[BLACK], Prisoners[WHITE]);
  ForeachPoint(y, x)
      if (goboard[x][y].StringNum == code) {
    FixLibs(StringList[code].color, x, y, REMOVED);
    GoRemoveStone(x, y);
    koX = x;
    koY = y;
  }
  DeleteString(code);
}

/* Fix the liberties of strings adjacent to x, y.  move indicates
   whether a stone of color was placed or removed at x, y
   This does not change liberty counts of friendly strings when a stone
   is placed.  Does not do captures. */
void FixLibs(color, x, y, move)
     enum bVal color;
     int x, y, move;
{
  int fstrings[4], fcnt, estrings[4], ecnt, i;
  enum bVal opcolor = BLACK;

  if (color == BLACK)
    opcolor = WHITE;
  Connect(color, x, y, fstrings, &fcnt, estrings, &ecnt);
  if (move == PLACED)
    for (i = 0; i < ecnt; i++)
      StringList[estrings[i]].liberties--;
  else				/* Stone removed so increment opcolor */
    for (i = 0; i < ecnt; i++)
      StringList[estrings[i]].liberties++;
}

void goSetHandicap(handicap)
{
  if (handicap < 2)
    return;

  bdk_place_stone(BLACK, 3, 3);
  bdk_place_stone(BLACK, 15, 15);

  if (handicap >= 3)
    bdk_place_stone(BLACK, 3, 15);
  if (handicap >= 4)
    bdk_place_stone(BLACK, 15, 3);
  if (handicap == 5 || handicap == 7 || handicap == 9)
    bdk_place_stone(BLACK, 9, 9);
  if (handicap >= 6) {
    bdk_place_stone(BLACK, 15, 9);
    bdk_place_stone(BLACK, 3, 9);
  }
  if (handicap >= 8) {
    bdk_place_stone(BLACK, 9, 15);
    bdk_place_stone(BLACK, 9, 3);
  }
}


void goRestart(handicap)
     int handicap;
{
  register int i;
  register struct bRec *gpt = &goboard[0][0];


  StringCount = 0;
  ko = FALSE;
  Prisoners[BLACK] = Prisoners[WHITE] = 0;
  intrPrisonerReport(0, 0);
  for (i = 0; i < 361; gpt++, i++) {
    gpt->Val = EMPTY;
    gpt->StringNum = 0;
  }
  goSetHandicap(handicap);
  current_move = 0;
  max_move = 0;
}


/* if any strings have been deleted as a result of the last move, this
   routine will delete the old string numbers from StringList and
   reassign string numbers. */
void RelabelStrings()
{
  unsigned int i, j, x, y;

  for (i = 0; i < DeletedStringCount; i++) {
    /* Relabel all higher strings */
    ForeachPoint(y, x)
	if (goboard[x][y].StringNum > DeletedStrings[i])
      goboard[x][y].StringNum--;
    /* Move the strings down */
    for (y = DeletedStrings[i]; y < StringCount; y++)
      StringList[y] = StringList[y + 1];
    /* fix the string numbers stored in the deleted list */
    for (j = i + 1; j < DeletedStringCount; j++)
      if (DeletedStrings[j] > DeletedStrings[i])
	DeletedStrings[j]--;
    StringCount--;
  }
}

/* Returns liberty count for x, y intersection.  Sets marked to true
   for each liberty */
int CountAndMarkLibs(x, y)
     int x, y;
{
  int tx, ty, i;
  int cnt = 0;


  for (i = 0; i < 4; i++) {
    tx = x + xVec[i];
    ty = y + yVec[i];
    if (LegalPoint(tx, ty) && goboard[tx][ty].Val == EMPTY
	&& goboard[tx][ty].marked == FALSE) {
      cnt++;
      goboard[tx][ty].marked = TRUE;
    }
  }
  return cnt;
}

/* Determine the number of liberties for a string given the string code
   num */
void CountLiberties(code)
     int code;
{
  int x, y, libcnt = 0;

  ForeachPoint(y, x)
      if (goboard[x][y].StringNum == code)
    libcnt += CountAndMarkLibs(x, y);
  EraseMarks();
  StringList[code].liberties = libcnt;
}

void CheckForEye(x, y, strings, cnt, recheck)
     int x, y, strings[4], cnt, *recheck;
{
  int i;

  for (i = 0; i < (cnt - 1); i++)
    if (strings[i] != strings[i + 1]) {
      /* Mark liberty for false eye check */
      goboard[x][y].marked = TRUE;
      (*recheck)++;
      return;
    }
  /* It is an eye */
  StringList[strings[i]].eyes += 1;
}

/* Set the eye count for the strings */
void CountEyes()
{
  int i, x, y, wstrings[4], bstrings[4], wcnt, bcnt, max, cnt, recheck = 0,
    eye;

  for (i = 1; i <= StringCount; i++)
    StringList[i].eyes = 0;

  ForeachPoint(y, x) {
    if (goboard[x][y].Val != EMPTY)
      continue;
    cnt = Connect(WHITE, x, y, wstrings, &wcnt, bstrings, &bcnt);
    max = Maxlibs(x, y);
    if (cnt == max && wcnt == 1 && bcnt == 0)
      StringList[wstrings[0]].eyes++;
    else if (cnt == max && bcnt == 1 && wcnt == 0)
      StringList[bstrings[0]].eyes++;
    else if (cnt == max && (bcnt == 0 || wcnt == 0)) {
      goboard[x][y].marked = TRUE;
      recheck++;
    }
  }

/*-- Now recheck marked liberties to see if two or more one eye --*/
/*-- strings contribute to a false eye */
  if (recheck == 0)
    return;

  ForeachPoint(y, x)
      if (goboard[x][y].marked) {
    recheck--;
    goboard[x][y].marked = FALSE;
    Connect(WHITE, x, y, wstrings, &wcnt, bstrings, &bcnt);
    /* If all the strings have at least one eye then all the
       strings are safe from capture because of the common
       liberty at x, y */
    eye = TRUE;
    for (i = 0; i < wcnt; i++)
      if (StringList[wstrings[i]].eyes == 0)
	eye = FALSE;
    if (eye)
      for (i = 0; i < wcnt; i++)
	StringList[wstrings[i]].eyes++;
    for (i = 0; i < bcnt; i++)
      if (StringList[bstrings[i]].eyes == 0)
	eye = FALSE;
    if (eye)
      for (i = 0; i < bcnt; i++)
	StringList[bstrings[i]].eyes++;
    if (recheck == 0)
      return;
  }
}


int foo[19][19];

/*----------------------------------------------------------------
-- CountUp()							--
--	Count up final scores at the end of the game.		--
----------------------------------------------------------------*/
void CountUp()
{
  int x, y;
  int CountFromPoint();
  float btotal, wtotal;
  char buff[512];

  blackTerritory = whiteTerritory = 0;
  ForeachPoint(y, x) {
    goboard[x][y].marked = FALSE;
    foo[x][y] = CNT_UNDECIDED;
  }
  ForeachPoint(y, x)
      if (goboard[x][y].Val == EMPTY && foo[x][y] == CNT_UNDECIDED) {
    FillPoints(x, y, CountFromPoint(x, y));
  }
  wtotal = whiteTerritory + Prisoners[BLACK] + dum;
  btotal = blackTerritory + Prisoners[WHITE];

  sprintf(buff, _("\
White  : %3d territory + %3d prisoners + %3.1f komi = %.1f\n\
Black  : %3d territory + %3d prisoners = %.0f\n\n\
Result : %s wins by %.1f"),
      whiteTerritory, Prisoners[BLACK], dum, wtotal,
      blackTerritory, Prisoners[WHITE], btotal,
      (btotal > wtotal ? _("Black") : _("White")),
      (btotal > wtotal ? (btotal - wtotal) : (wtotal - btotal)));
  show_message_box(buff);

  if (btotal > wtotal)
    show_message(_("Black Wins!"));
  else if (wtotal > btotal)
    show_message(_("White Wins!"));
  else
    show_message(_("Even"));
}

void FillPoints(int x, int y, int val)
{
  int i;
  int tx, ty;


  if ((foo[x][y] = val) == CNT_BLACK_TERR)
    blackTerritory++;
  else if (val == CNT_WHITE_TERR)
    whiteTerritory++;
  for (i = 0; i < 4; i++) {
    tx = x + xVec[i];
    ty = y + yVec[i];
    if (!LegalPoint(tx, ty))
      continue;
    if (goboard[tx][ty].Val == EMPTY && foo[tx][ty] == CNT_UNDECIDED)
      FillPoints(tx, ty, val);
  }
}

int CountFromPoint(x, y)
     int x, y;
{
  int i;
  int tx, ty;
  int blkcnt = 0, whtcnt = 0;
  int baz;

  goboard[x][y].marked = TRUE;
  for (i = 0; i < 4; i++) {
    tx = x + xVec[i];
    ty = y + yVec[i];
    if (!LegalPoint(tx, ty))
      continue;
    if (goboard[tx][ty].Val == BLACK)
      blkcnt++;
    else if (goboard[tx][ty].Val == WHITE)
      whtcnt++;
    else {
      if (goboard[tx][ty].marked)
	continue;
      baz = CountFromPoint(tx, ty);
      if (baz == CNT_NOONE)
	return CNT_NOONE;
      else if (baz == CNT_BLACK_TERR)
	blkcnt++;
      else if (baz == CNT_WHITE_TERR)
	whtcnt++;
    }
    if (blkcnt && whtcnt)
      return CNT_NOONE;
  }
  if (blkcnt && !whtcnt)
    return CNT_BLACK_TERR;
  else if (whtcnt && !blkcnt)
    return CNT_WHITE_TERR;
  else
    return CNT_UNDECIDED;
}


/*---------------*/

int play_level = 7;

void restart_baduk(int handicap)
{
  register int i;
  register struct bRec *gpt = &goboard[0][0];


  StringCount = 0;
  ko = FALSE;
  ignore_takecorner = FALSE;
  Prisoners[BLACK] = Prisoners[WHITE] = 0;
  intrPrisonerReport(0, 0);
  for (i = 0; i < 361; gpt++, i++) {
    gpt->Val = EMPTY;
    gpt->StringNum = 0;
  }
  initGPUtils();
  goSetHandicap(handicap);
  current_move = 0;
  max_move = 0;
}

/*  ʱȭ */
void bdk_init()
{
}
