/* Baduki - Computer Baduk(Go) Program 
   Copyright(c) 1998-1999 Lim Jaebum <artist@soback.kornet21.net>

   This program is free software; you can redistribute it and'or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
   USA */

/* $Id: main.c,v 1.26 1999/08/05 19:22:10 artist Exp $ */ 

#include <config.h>
#include "intldefs.h"

#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>
#include <errno.h>
#include <termios.h>
#include <unistd.h>
#include <time.h>
#include <signal.h>
#include "gtkgoboard.h"
#include "baduki.h"
#include "gmp.h"
#include "gpointer.h"

#define SHOW_COORDINATES 1
#define HIGH_CONTRAST 2

static void exit_callback(void);
extern char *g_vsprintf(const gchar * fmt, va_list * args, va_list * args2);

/* ٵ  */
static void pressed_callback(GtkGoBoard * go_board, gint x, gint y, gint bt, gpointer data);
static void released_callback(GtkGoBoard * go_board, gint x, gint y, gint bt, gpointer data);
static void clicked_callback(GtkGoBoard * go_board, gint x, gint y, gpointer data);
static void enter_callback(GtkGoBoard * go_board, gint x, gint y, gpointer data);
static void leave_callback(GtkGoBoard * go_board, gint x, gint y, gpointer data);

/* ٵ  */
void bdk_new_game(GtkWidget * widget, gpointer data);
void bdk_pass(GtkWidget * widget, gpointer data);
void bdk_back(GtkWidget * widget, gpointer data);
void bdk_next_move(GtkWidget * widget, gpointer data);
void bdk_score(GtkWidget * widget, gpointer data);
void bdk_quit(GtkWidget * widget, GtkWidget * window);
void bdk_set_handicap(GtkWidget * widget, gpointer data);
void bdk_set_display_mode(GtkWidget * widget, gpointer data);
void baduki_think(void);
void bdk_hint(GtkWidget * widget, gpointer data);
int bdk_gmp_init(void);
int bdk_gmp_move(void);

/* Ÿ  Լ */
int CheckPasses(void);
void update_turn(void);

GtkGoBoard *go_board;
GtkWidget *statusbar;
GtkWidget *combo;
GtkWidget *label_entry;

GtkWidget *time_label[2], *score_label[2], *position_label[2];
GtkWidget *p_frame[2];
GtkWidget *info_label;

guint timer_id = 0;
guint message_id = 0;
gchar message_group[1024];

int ingame = 0, counting = 0, pass_count = 0, current_turn;
int current_handicap = 0, new_handicap = 0;
extern float dum;
int display_mode = DMODE_PLAY;
extern int play_level;
extern int playLevel;
int player_type[2] = {TYPE_BADUKI, TYPE_HUMAN};
char player_name[2][80] = {"/dev/cua0", "/dev/cua0"};
int last_x[2], last_y[2];
guint32 timer[2], ftimer[2], turn_begin_time[2];
int bdk_debug = FALSE, bdk_debug_next = TRUE;
extern int tryLimit;

const char baduki_logo[] = 
"..................."
"..................."
".....X.OOOOO.....X."
".X.X.X.O......X..X."
".X.X.X.OOOOO.X.X.X."
".XXX.XX......X.X.X."
".X.X.X.OOOOO.X.X.X."
".X.X.X...O...X.X.X."
" XXX.X.OOOOO..X..X."
".....X.....O.....X."
".....X....O......X."
"..................."
".OO......O...O....."
".O.O.....O...O...X."
".OO..XX.OOX.XO.O..."
".O.OX.XO.OX.XOO..X."
".O.OX.XO.OX.XOO..X."
".OO..XX.OO.XXO.O.X."
"...................";

extern int current_move, max_move;
extern char *playReason;

int gmp_mode = FALSE;
int sgf_mode = FALSE;
extern struct altmovestype altmoves[];
int show_altmoves = TRUE;
extern int showTrees;
int gmp_in = -1, gmp_out = -1;
Gmp *gmpp;

extern int inGenState;
extern stringRec sList[maxString];
extern int SMap[maxString];
extern groupRec gList[];
extern groupRec wgList[];
extern vsgRec vsgList[];
extern int maxStringID;

/* gmp .. :  (98. 5. 1) */
void waitForNewGame(Gmp * ge);
void play_gmp_Game(Gmp * ge, int size, int himFirst);
#define LOG(dd)		fprintf(stderr, (dd));fprintf(stderr, "\n");


/* from gnugo 2.0 beta */
/* cgoban sends us a sigterm when it wants us to die. But it doesn't
 * close the pipe, so we cannot rely on gmp to pick up an error.
 * We want to keep control so we can close the output sgf file
 * properly, so we trap the signal.
 */

static volatile int time_to_die = 0;   /* set by signal handlers */

static void sigterm_handler(int sig)
{
  time_to_die = 1;

  write(2, "*SIGTERM*\n", 10);  /* bad to use stdio in a signal handler */

  close(0);  /* this sure forces gmp.c to return an gmp_err  !!! */

  /* I though signal handlers were one-shot, yet on my linux box it is kept.
   * Restore the default behaviour so that a second signal has the
   * original effect - in case we really are stuck in a loop
   */

  signal(sig, SIG_DFL);

  /* schedule a SIGALRM in 5 seconds, in case we haven't cleaned up by then
   * - cgoban sends the SIGTERM only once 
   */

  alarm(5);
}

void gmp_main(void)
{
  Gmp *ge;
  GmpResult result;
  const char *error;
  int gx, gy;

  gmp_mode = TRUE;
  show_altmoves = FALSE;
/*  playLevel = 7; */
  ge = gmp_create(0, 1);

  /*
   * I really should look at the command line and set up the handicap,
   *   board size, etc. better than this.
   */
  gmp_startGame(ge, -1, -1, 5.5, -1, -1);
  waitForNewGame(ge);
  if (gmp_handicap(ge) > 9) {
    fprintf(stderr, "I don't know how to play handicap games more than 9.\n");
    exit(1);
  }
  play_gmp_Game(ge, gmp_size(ge), gmp_iAmWhite(ge));

  /* from gnugo 2.0 beta */

  /* We hang around here until cgoban asks us to go, since
   * sometimes cgoban crashes if we exit first
   */

  fprintf(stderr, "Baduki: Game over\n");

  while (!time_to_die) {
    do {
      result = gmp_check(ge, 1, &gx, &gy, &error);
    } while (result == gmp_nothing);
    fprintf(stderr, "Message %d from gmp\n", result);
    if (result == gmp_err)
      break;
  }

  exit(0);
}


void waitForNewGame(Gmp * ge)
{
  GmpResult result;
  const char *err;

  do {
    result = gmp_check(ge, 1, NULL, NULL, &err);
  } while ((result == gmp_nothing) || (result == gmp_reset));
  if (result == gmp_err) {
    fprintf(stderr, "baduki: Error \"%s\" occurred.\n", err);
    exit(1);
  } else if (result != gmp_newGame) {
    fprintf(stderr, "Expecting a newGame, got %s\n",
	gmp_resultString(result));
    exit(1);
  }
}

void play_gmp_Game(Gmp * ge, int size, int IamWhite)
{
  int x, y;
  int gx, gy;
  int myturn;
  int move_num = 0;
  GmpResult gmp_message;
  const char *gmp_error;
  int my_color, other_color;

  ingame = 0;
  current_handicap = gmp_handicap(ge);
/*  playLevel = 7; */
  pass_count = 0;

  last_x[BLACK] = last_y[BLACK] = last_x[WHITE] = last_y[WHITE] = 0;

  if (IamWhite) {
    player_type[WHITE] = TYPE_BADUKI;
    player_type[BLACK] = TYPE_GMP;
    my_color = WHITE;
    other_color = BLACK;
  } else {
    player_type[BLACK] = TYPE_BADUKI;
    player_type[WHITE] = TYPE_GMP;
    my_color = BLACK;
    other_color = WHITE;
  }

/*-- clear goban *before* calling goRestart() --*/
  goRestart(current_handicap);

  ingame = TRUE;

  /* fprintf(stderr, "size: %d\n", size); */

  if ((!IamWhite && current_handicap < 2) ||
      (IamWhite && current_handicap >= 2))
    myturn = TRUE;
  else
    myturn = FALSE;

  for (;;) {
    if (myturn) {
      move_num++;
      if (genMove(my_color, &x, &y)) {
/*	fprintf(stderr, "Move %d: %c %d\n", move_num,
	    x < 8 ? x + 'A' : x + 'B', y + 1); */
	gmp_sendMove(ge, x, 18 - y);
	bdk_place_stone(my_color, x, y);
	pass_count = 0;
      } else {
	fprintf(stderr, "Move %d: pass\n", move_num);
	gmp_sendPass(ge);
	if (++pass_count == 2)
	  return;
      }

    }
    myturn = TRUE;
    do {
      gmp_message = gmp_check(ge, 1, &gx, &gy, &gmp_error);
/*      fprintf(stderr, "Got : %d %d\n", gx, gy); */
      x = gx;
      y = gy;
    } while (gmp_message == gmp_nothing);
    if (gmp_message == gmp_err) {
      fprintf(stderr, "baduki: Got gmp_error \"%s\"\n", gmp_error);
      exit(1);
    }
    if (gmp_message == gmp_move) {
      move_num++;
      if (!bdk_place_stone(other_color, x, 18 - y)) {
	fprintf(stderr, "Invalid Position %d %d\n", x, y);
      }
      pass_count = 0;
    } else if (gmp_message == gmp_pass) {
      move_num++;
      if (++pass_count == 2)
	return;
    } else if (gmp_message == gmp_reset) {
      /* Game over! */
      return;
    } else if (gmp_message == gmp_undo) {
      fprintf(stderr, "baduki: I am asked to undo %d moves.\n", x);
      if ((x & 1) == 0) {
	/*
	 * Since an even number of undos were made, it is still the other
	 *   player's turn.  This flag makes me skip my turn.
	 */
	myturn = FALSE;
      }
    } else {
      fprintf(stderr, "Got a \"%s\" command during game play.  Exiting.\n",
	  gmp_resultString(gmp_message));
      exit(1);
    }
    save_current_to_sgf();
  }
}

#define SHOW_BOARD	1
#define SHOW_PBOARD	2
#define SHOW_FBOARD	3

struct dmode_type dmode[] =
{ {N_("Default"), DMODE_PLAY, SHOW_FBOARD, &valueBoard},
  {N_("Score"), DMODE_SCORE, SHOW_PBOARD, &scoreBoard},
  {N_("GIDMap"), DMODE_GROUP, SHOW_BOARD, &GIDMap},
  {N_("WGIDMap"), DMODE_WGROUP, SHOW_BOARD, &wGIDMap},
  {N_("CLAIM"), DMODE_CLAIM, SHOW_PBOARD, &claim},
  {N_("BORD"), DMODE_BORD, SHOW_PBOARD, &bord},
  {N_("NDBOARD"), DMODE_NDBOARD, SHOW_PBOARD, &ndbord},
  {N_("SAFEBD"), DMODE_SAFEBOARD, SHOW_PBOARD, &safeboard},
  {N_("SGROUP"), DMODE_SGROUP, SHOW_BOARD, &sGroups},
  {N_("vEyeMap"), DMODE_VEYE, SHOW_BOARD, &vEyeMap},
/*  {N_("THREAT"), DMODE_THREAT, SHOW_BOARD, &threatBord}, */
  {N_("JUMP1"), DMODE_JUMP1, SHOW_BOARD, &jump1Map},
  {N_("STRINGID"), DMODE_STRINGID, SHOW_BOARD, &stringIDs},
  {N_("CONNECT"), DMODE_CONNECT, SHOW_BOARD, &connectMap},
  {N_("CONNECT2"), DMODE_CONNECT2, SHOW_BOARD, &connectMap2},
  {N_("SAFECON"), DMODE_SAFECON, SHOW_BOARD, &safeConnect},
  {N_("PROT"), DMODE_PROT, SHOW_PBOARD, &protPoints},
  {N_("POWER"), DMODE_POWER, SHOW_BOARD, &powerBoard},
  {N_("POWER1"), DMODE_POWER, SHOW_BOARD, &powerBoard1},
  {N_("POWER2"), DMODE_POWER2, SHOW_BOARD, &powerBoard2},
  {N_("LIBERTY"), DMODE_LIBERTY, SHOW_BOARD, &libBoard},
  {N_("MYSTONES"), DMODE_MYSTONES, SHOW_BOARD, &myStones},
  {N_("HISSTONES"), DMODE_HISSTONES, SHOW_BOARD, &hisStones},
  {N_("IGNORESAFE"), DMODE_HISSTONES, SHOW_BOARD, &ignoreSafe},
  {NULL, -1, -1, NULL}
};

void show_board(intBoard brd)
{
  int x, y;
  char buf[20];
  
  for (y = 18; y >= 0; y--) {
    for (x = 0; x <= 18; x++) {
      if (brd[x][y] != 0) {
        sprintf(buf, "%d", brd[x][y]);
        gtk_go_board_set_label(go_board, x+1, y+1, buf);
      } else
        gtk_go_board_set_label(go_board, x+1, y+1, "");
    }
  }
}

void show_fboard(intBoard brd)
{
  int x, y;
  char buf[20];
  
  for (y = 18; y >= 0; y--) {
    for (x = 0; x <= 18; x++) {
      if (brd[x][y] != 0) {
        sprintf(buf, "%d", (brd[x][y] + 5) / 10);
        gtk_go_board_set_label(go_board, x+1, y+1, buf);
      } else
        gtk_go_board_set_label(go_board, x+1, y+1, "");
    }
  }
}

void show_pboard(intBoard brd)
{
  int x, y;
  for (y = 18; y >= 0; y--) {
    for (x = 0; x <= 18; x++) {
      if (brd[x][y] != 0) {
        if (current_turn == BLACK)
          gtk_go_board_set_plabel(go_board, x+1, y+1, -brd[x][y]);
        else
          gtk_go_board_set_plabel(go_board, x+1, y+1, brd[x][y]);
      } else
        gtk_go_board_set_label(go_board, x+1, y+1, "");
    }
  }
}

void show_labels()
{
  int x, y, bs1, bs2, ws2, ws1;
  char buf[80];
  
  switch(dmode[display_mode].mode) {
    case DMODE_SCORE:
      show_pboard(scoreBoard);
      for (ws1 = ws2 = bs1 = bs2 = x = 0; x < 19; x++)
        for (y = 0; y < 19; y++) {
          switch(scoreBoard[x][y]) {
            case -2:
              ws2++;
              break;
            case -1:
              ws1++;
              break;
            case 1:
              bs1++;
              break;
            case 2:
              bs2++;
              break;
          }
        }
      sprintf(buf, "1: %2d, 2: %2d (%2d) -1: %2d, -2: %2d (%2d) -- %d",
      	bs1, bs2, (bs1+bs2*2)/2, ws1, ws2, (ws1+ws2*2)/2,
      	(bs1 + bs2*2 - (ws1 + ws2*2)) / 2);
      show_message(buf);
      break;
  }
  if (dmode[display_mode].func == SHOW_BOARD)
    show_board(*dmode[display_mode].board);
  else if (dmode[display_mode].func == SHOW_PBOARD)
    show_pboard(*dmode[display_mode].board);
  else if (dmode[display_mode].func == SHOW_FBOARD)
    show_fboard(*dmode[display_mode].board);
}

/* sgf м :  (98. 6. 2) */
#define BUF_SIZE	1024

void printfBoard(intBoard brd, char *name)
{
  int x, y;
  printf("%s\n", name);
  for (y = 18; y >= 0; y--) {
    for (x = 0; x <= 18; x++)
      printf("%2d ", brd[x][y]);
    printf("\n");
  }
}


void merong()
{
  extern int inGenState;
  extern stringRec sList[maxString];
  extern int maxStringID;
  int i;

  inGenState = TRUE;
  respreicen();
  markDead();
  markLive();
  spread();
  genConnects();

  printfBoard(claim, "claim");
  printfBoard(bord, "bord");
  printfBoard(ndbord, "ndbord");
  printfBoard(sGroups, "sGroups");
  printfBoard(threatBord, "threatBord");
  printfBoard(stringIDs, "stringIDs");
  printfBoard(connectMap, "connectMap");
  printfBoard(protPoints, "protPoints");
  printf("String:\n");
  for (i = 1; i <= maxStringID; i++)
    printf("%3d: Mark %d Live %d Safe %d Dead %d libC %d Eyes %d size %d lx %d ly %d\n",
	i, sList[i].stringMark,
	sList[i].isLive, sList[i].isSafe, sList[i].isDead, sList[i].libC,
	sList[i].numEyes, sList[i].size, sList[i].lx, sList[i].ly);
}

void sgf_main(char *filename, int breakat)
{
  FILE *f;
  char ch, buf[BUF_SIZE + 2], dbuf[BUF_SIZE + 2], lastbuf[BUF_SIZE + 2];
  int last_x = -1, last_y = -1, i, move_num = 0;
  int my_x, my_y;
  enum bVal last_color = EMPTY;
  enum sgfcmdval {
    Skip, GetCmd, GetArg
  } sgfcmd = Skip;

  sgf_mode = TRUE;
  gmp_mode = TRUE;

  if (!(f = fopen(filename, "r"))) {
    perror("Error!");
    return;
  }
  goRestart(0);

  while (TRUE) {
    ch = getc(f);
    if (ch && ch != EOF) {
      switch (ch) {
      case '[':
/*        printf("!!buf: %d <%s>!!", strlen(buf), buf); */
	if (!buf[0])
	  strcpy(buf, lastbuf);
	dbuf[0] = '\0';
	if (!strcmp(buf, "B") || !strcmp(buf, "AB")) {
	  last_color = BLACK;
	  sgfcmd = GetArg;
	} else if (!strcmp(buf, "W") || !strcmp(buf, "AW")) {
	  last_color = WHITE;
	  sgfcmd = GetArg;
	} else {
	  sgfcmd = Skip;
	}
	break;
      case ']':
	if (sgfcmd != Skip && last_color != EMPTY) {
	  last_x = dbuf[0] - 'a';
	  last_y = dbuf[1] - 'a';
	  if (last_x >= 0 && last_x <= 18 &&
	      last_y >= 0 && last_y <= 18)
	    if (!strcmp(buf, "AB") || !strcmp(buf, "AW")) {
	      bdk_place_stone(last_color, last_x, 18 - last_y);
	    }
	}
	sgfcmd = GetCmd;
	strcpy(lastbuf, buf);
	buf[0] = '\0';
	break;
      case ';':
      case ')':
	if (last_color != EMPTY && last_x >= 0 && last_y >= 0) {
/*        printf("CCC: %d, XXX : %d, YYY : %d\n", last_color, last_x, last_y); */
	  /* */
	  move_num++;
	  if (!breakat || move_num == breakat)
	    printf("C[");
	  if (move_num == breakat) {
	    genBord(last_color);
	    merong();
	  }
	  if ((!breakat || move_num == breakat) &&
	      !genMove(last_color, &my_x, &my_y)) {
	    printf("pass");
	  }
	  if (!breakat || move_num == breakat)
	    printf("]");
	  if (last_x >= 0 && last_x <= 18 &&
	      last_y >= 0 && last_y <= 18)
	    bdk_place_stone(last_color, last_x, 18 - last_y);
	  if (!breakat || move_num == breakat) {
	    for (i = 0; altmoves[i].px; i++)
	      printf("MA[%c%c]", altmoves[i].px + 'a' - 1, 19 - altmoves[i].py + 'a');
	    if (altmoves[0].px)
	      printf("TR[%c%c]", my_x + 'a', 18 - my_y + 'a');
	  }
	}
	last_color = EMPTY;
	buf[0] = '\0';
	sgfcmd = GetCmd;
	break;
      default:
	switch ((int) sgfcmd) {
	case GetCmd:
	  if (strlen(buf) < BUF_SIZE && isalnum(ch))
	    sprintf(buf, "%s%c", buf, ch);
	  break;
	case GetArg:
	  if (strlen(dbuf) < BUF_SIZE && isalnum(ch))
	    sprintf(dbuf, "%s%c", dbuf, ch);
	  break;
	}
	break;
      }
      printf("%c", ch);
    } else {
      fclose(f);
      return;
    }
  }
}

void load_sgf(char *filename, int breakat)
{
  FILE *f;
  char ch, buf[BUF_SIZE + 2], dbuf[BUF_SIZE + 2], lastbuf[BUF_SIZE + 2];
  int last_x = -1, last_y = -1, move_num = 0;
  enum bVal last_color = EMPTY;
  enum sgfcmdval {
    Skip, GetCmd, GetArg
  } sgfcmd = Skip;

  if (!(f = fopen(filename, "r"))) {
    perror("Error!");
    return;
  }
  goRestart(0);
  ingame = TRUE;
  player_type[BLACK] = TYPE_HUMAN;
  player_type[WHITE] = TYPE_HUMAN;

  while (TRUE) {
    ch = getc(f);
    if (ch && ch != EOF) {
      switch (ch) {
      case '[':
	if (!buf[0])
	  strcpy(buf, lastbuf);
	dbuf[0] = '\0';
	if (!strcmp(buf, "B") || !strcmp(buf, "AB")) {
	  last_color = BLACK;
	  sgfcmd = GetArg;
	} else if (!strcmp(buf, "W") || !strcmp(buf, "AW")) {
	  last_color = WHITE;
	  sgfcmd = GetArg;
	} else {
	  sgfcmd = Skip;
	}
	break;
      case ']':
	if (sgfcmd != Skip && last_color != EMPTY) {
	  last_x = dbuf[0] - 'a';
	  last_y = dbuf[1] - 'a';
	  if (last_x >= 0 && last_x <= 18 &&
	      last_y >= 0 && last_y <= 18)
	    if (!strcmp(buf, "AB") || !strcmp(buf, "AW")) {
	      bdk_place_stone(last_color, last_x, 18 - last_y);
	      current_turn = last_color == BLACK ? WHITE : BLACK;
	    }
	  else if (last_x == 19 && last_y == 19 &&
	  	(!strcmp(buf, "AB") || !strcmp(buf, "AW"))) {
	    bdk_place_stone(last_color, -1, -1);
	    current_turn = last_color == BLACK ? WHITE : BLACK;
	  }
	}
	sgfcmd = GetCmd;
	strcpy(lastbuf, buf);
	buf[0] = '\0';
	break;
      case ';':
      case ')':
	if (last_color != EMPTY && last_x >= 0 && last_y >= 0) {
	  move_num++;
	  if (last_x >= 0 && last_x <= 18 &&
	      last_y >= 0 && last_y <= 18)
	    bdk_place_stone(last_color, last_x, 18 - last_y);
	  else if (last_x == 19 && last_y == 19)
	    bdk_place_stone(last_color, -1, -1);
	  current_turn = last_color == BLACK ? WHITE : BLACK;
	  if (move_num == breakat) {
	    fclose(f);
	    return;
	  }
	}
	last_color = EMPTY;
	buf[0] = '\0';
	sgfcmd = GetCmd;
	break;
      default:
	switch ((int) sgfcmd) {
	case GetCmd:
	  if (strlen(buf) < BUF_SIZE && isalnum(ch))
	    sprintf(buf, "%s%c", buf, ch);
	  break;
	case GetArg:
	  if (strlen(dbuf) < BUF_SIZE && isalnum(ch))
	    sprintf(dbuf, "%s%c", dbuf, ch);
	  break;
	}
	break;
      }
    } else {
      fclose(f);
      return;
    }
  }
  fclose(f);
  return;
}

static GtkWidget *create_mode_menu(void)
{
  GtkWidget *menu;
  GtkWidget *menuitem;
  GSList *string;
  int i;

  menu = gtk_menu_new();
  string = NULL;

  for (i = 0; dmode[i].mode != -1; i++) {
    menuitem = gtk_radio_menu_item_new_with_label(string, _(dmode[i].name));
    gtk_signal_connect(GTK_OBJECT(menuitem), "activate",
	GTK_SIGNAL_FUNC(bdk_set_display_mode), GINT_TO_POINTER(i));
    string = gtk_radio_menu_item_group(GTK_RADIO_MENU_ITEM(menuitem));
    gtk_menu_append(GTK_MENU(menu), menuitem);
    gtk_widget_show(menuitem);
  }

  return menu;
}

void option_dialog();

void show_baduki_logo()
{
  int i, j;
  
  for (i = 0; i < 19; i++)
    for (j = 0; j < 19; j++) {
      switch(baduki_logo[j*19+i]) {
      case 'X':
        gtk_go_board_set_stone(go_board, i+1, 19-j, GTK_GO_BOARD_SOLID_BLACK);
        break;
      case 'O':
        gtk_go_board_set_stone(go_board, i+1, 19-j, GTK_GO_BOARD_SOLID_WHITE);
        break;
      }
    }
}

#define RUN_BADUKI	0
#define RUN_GMP		1
#define RUN_SGF		2
#define RUN_LOAD_SGF	3

int main(int argc, char *argv[])
{
  GtkWidget *window, *vbox, *hbox, *vvbox, *hhbox;
  GtkWidget *button, *optionmenu;
  GtkWidget *frame, *framevbox, *dlabel, *dmode_label;
  char buf[80], fname[256];
  int i, mode = 0, break_at = 0;

  setlocale (LC_ALL, "");
  bindtextdomain(PACKAGE, LOCALEDIR);
  textdomain(PACKAGE);

  for (i = 1; i < argc; i++) {
    if (!strncmp(argv[i], "-g", 2))
      mode = RUN_GMP;
    else if (!strncmp(argv[i], "-s", 2)) {
      mode = RUN_SGF;
      if (argc <= i+1) {
        fprintf(stderr, "Usage: %s -sgf <filename>\n", argv[0]);
        exit(0);
      }
      i++;
      strcpy(fname, argv[i]);
      if (argc > i+1 && atoi(argv[i+1]) > 0) {
        i++;
        break_at = atoi(argv[i]);
      }
    } else if (!strncmp(argv[i], "-l", 2)) {
      mode = RUN_LOAD_SGF;
      if (argc <= i+1) {
        fprintf(stderr, "Usage: %s -lsgf <filename> [move]\n", argv[0]);
        exit(0);
      }
      i++;
      strcpy(fname, argv[i]);
      if (argc > i+1 && atoi(argv[i+1]) > 0) {
        i++;
        break_at = atoi(argv[i]);
      }
    } else if (!strncmp(argv[i], "-L", 2)) {
      if (argc <= i+1) {
        fprintf(stderr, "Usage: %s -Level <level>\n", argv[0]);
        exit(0);
      }
      i++;
      playLevel = atoi(argv[i]);
      if (playLevel < 1 || playLevel > 12) {
        printf("Set level between 1-12\n");
        exit(0);
      }
    } else if (!strncmp(argv[i], "-h", 2) ||
    	!strncmp(argv[i], "--h", 3)) {
      printf("Baduki %s\n", VERSION);
      printf("\n"
      	"-L <level>	Set Level\n"
      	"-g		Playing gmp mode\n"
      	"-s <filename>	Analize a sgf file\n"
      	"-l <filename> [move]	Load a sgf file\n");
      exit(0);
    }
  }
  
  tryLimit = 15 + playLevel * playLevel;
  
  if (!isatty(0))
    mode = RUN_GMP;

  init_pattern();
  srandom(time(0));
  
  if (mode == RUN_GMP) {
    gmp_main();
    exit(0);
  } else if (mode == RUN_SGF) {
    sgf_main(fname, break_at);
    exit(0);
  }

  gtk_set_locale();
  gtk_init(&argc, &argv);

  {
    char *file = g_strconcat (PKGDATADIR, "/baduki.gtkrc", NULL);
    gtk_rc_parse(file);
    g_free (file);
  }

  window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name(window, "baduki");
  gtk_signal_connect(GTK_OBJECT(window), "delete_event",
      GTK_SIGNAL_FUNC(exit_callback), NULL);

  {
    vbox = gtk_vbox_new(FALSE, 0);
    gtk_widget_set_name(vbox, "top_frame");
    gtk_container_add(GTK_CONTAINER(window), vbox);

    {
      hbox = gtk_hbox_new(FALSE, 0);
      gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);

      vvbox = gtk_vbox_new(FALSE, 0);
      gtk_widget_set_name(vvbox, "title_box");
/*      gtk_container_border_width(GTK_CONTAINER(vvbox), 5); */

      gtk_box_pack_start(GTK_BOX(hbox), vvbox, TRUE, TRUE, 0);
      frame = gtk_frame_new(NULL);
      gtk_widget_set_name(frame, "title_frame");
      gtk_container_border_width(GTK_CONTAINER(frame), 3);
      gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_ETCHED_OUT);
              
      gtk_box_pack_start(GTK_BOX(vvbox), frame, FALSE, FALSE, 0);
      
	  {
	    framevbox = gtk_vbox_new(TRUE, 2);
	    gtk_container_border_width(GTK_CONTAINER(framevbox), 5);
	    gtk_container_add(GTK_CONTAINER(frame), framevbox);

	    sprintf(buf, _("Baduki %s"), VERSION);
	    dlabel = gtk_label_new(buf);
	    gtk_box_pack_start(GTK_BOX(framevbox), dlabel,
		FALSE, TRUE, 0);
	    gtk_widget_show(dlabel);

	    info_label = gtk_label_new("  --  ");
	    gtk_box_pack_start(GTK_BOX(framevbox),info_label,
		FALSE, TRUE, 0);
	    gtk_widget_show(info_label);

	    gtk_widget_show(framevbox);
	  }
      gtk_widget_show((GtkWidget *) frame);
      gtk_widget_show((GtkWidget *) vvbox);
      
      {
	go_board = (GtkGoBoard *) gtk_go_board_new(19, 19);
	gtk_go_board_set_high_contrast(GTK_GO_BOARD(go_board), FALSE);
	gtk_go_board_set_show_coordinates(GTK_GO_BOARD(go_board), TRUE);
	gtk_go_board_set_coord_style(GTK_GO_BOARD(go_board), GTK_GO_BOARD_IGS_COORD);

	gtk_signal_connect(GTK_OBJECT(go_board), "pressed",
	    GTK_SIGNAL_FUNC(pressed_callback), NULL);
	gtk_signal_connect(GTK_OBJECT(go_board), "released",
	    GTK_SIGNAL_FUNC(released_callback), NULL);
	gtk_signal_connect(GTK_OBJECT(go_board), "clicked",
	    GTK_SIGNAL_FUNC(clicked_callback), NULL);
	gtk_signal_connect(GTK_OBJECT(go_board), "enter",
	    GTK_SIGNAL_FUNC(enter_callback), NULL);
	gtk_signal_connect(GTK_OBJECT(go_board), "leave",
	    GTK_SIGNAL_FUNC(leave_callback), NULL);
	gtk_box_pack_start(GTK_BOX(vvbox), (GtkWidget *) go_board, TRUE, TRUE, 0);
	gtk_widget_show((GtkWidget *) go_board);
      }
      gtk_widget_show((GtkWidget *) vvbox);

      {
	vvbox = gtk_vbox_new(FALSE, 0);
	gtk_container_border_width(GTK_CONTAINER(vvbox), 5);
	gtk_box_pack_start(GTK_BOX(hbox), vvbox, FALSE, TRUE, 0);

	{
	  p_frame[BLACK] = gtk_frame_new(_("Black"));
	  gtk_frame_set_label_align(GTK_FRAME(p_frame[BLACK]), 0.5, 0.5);
	  gtk_box_pack_start(GTK_BOX(vvbox), p_frame[BLACK], FALSE, TRUE, 0);

	  {
	    framevbox = gtk_vbox_new(TRUE, 2);
	    gtk_container_border_width(GTK_CONTAINER(framevbox), 5);
	    gtk_container_add(GTK_CONTAINER(p_frame[BLACK]), framevbox);

	    time_label[BLACK] = gtk_label_new(_("Time: 0:00:00"));
	    gtk_widget_set_name(time_label[BLACK], "black-time-label");
	    gtk_box_pack_start(GTK_BOX(framevbox), time_label[BLACK],
		FALSE, TRUE, 0);
	    gtk_widget_show(time_label[BLACK]);

	    score_label[BLACK] = gtk_label_new(_("Captures:  0"));
	    gtk_widget_set_name(score_label[BLACK], "black-score-label");
	    gtk_box_pack_start(GTK_BOX(framevbox), score_label[BLACK],
		FALSE, TRUE, 0);
	    gtk_widget_show(score_label[BLACK]);

	    position_label[BLACK] = gtk_label_new(_("Last Move:  --  "));
	    gtk_widget_set_name(position_label[BLACK], "black-position-label");
	    gtk_box_pack_start(GTK_BOX(framevbox), position_label[BLACK],
		FALSE, TRUE, 0);
	    gtk_widget_show(position_label[BLACK]);

	    gtk_widget_show(framevbox);
	  }
	  gtk_widget_show(p_frame[BLACK]);
	}

	{
	  p_frame[WHITE] = gtk_frame_new(_("White"));
	  gtk_frame_set_label_align(GTK_FRAME(p_frame[WHITE]), 0.5, 0.5);
	  gtk_box_pack_start(GTK_BOX(vvbox), p_frame[WHITE], FALSE, TRUE, 0);

	  {
	    framevbox = gtk_vbox_new(TRUE, 2);
	    gtk_container_border_width(GTK_CONTAINER(framevbox), 5);
	    gtk_container_add(GTK_CONTAINER(p_frame[WHITE]), framevbox);

	    time_label[WHITE] = gtk_label_new(_("Time: 0:00:00"));
	    gtk_widget_set_name(time_label[WHITE], "white-time-label");
	    gtk_box_pack_start(GTK_BOX(framevbox), time_label[WHITE],
		FALSE, TRUE, 0);
	    gtk_widget_show(time_label[WHITE]);

	    score_label[WHITE] = gtk_label_new(_("Captures:  0"));
	    gtk_widget_set_name(score_label[WHITE], "white-score-label");
	    gtk_box_pack_start(GTK_BOX(framevbox), score_label[WHITE],
		FALSE, TRUE, 0);
	    gtk_widget_show(score_label[WHITE]);

	    position_label[WHITE] = gtk_label_new(_("Last Move:  --  "));
	    gtk_widget_set_name(position_label[WHITE], "white-position-label");
	    gtk_box_pack_start(GTK_BOX(framevbox), position_label[WHITE],
		FALSE, TRUE, 0);
	    gtk_widget_show(position_label[WHITE]);

	    gtk_widget_show(framevbox);
	  }
	  gtk_widget_show(p_frame[WHITE]);
	}

	{
	  frame = gtk_frame_new(_("Commands"));
	  gtk_frame_set_label_align(GTK_FRAME(frame), 0.5, 0.5);
	  gtk_box_pack_start(GTK_BOX(vvbox), frame, FALSE, TRUE, 0);

	  {
	    framevbox = gtk_vbox_new(TRUE, 2);
	    gtk_container_border_width(GTK_CONTAINER(framevbox), 5);
	    gtk_container_add(GTK_CONTAINER(frame), framevbox);

	    {
	      button = gtk_button_new_with_label(_("New Game"));
	      gtk_signal_connect(GTK_OBJECT(button), "clicked",
		  GTK_SIGNAL_FUNC(bdk_new_game), NULL);
	      gtk_box_pack_start(GTK_BOX(framevbox), button, FALSE, TRUE, 0);
	      gtk_widget_show(button);
	    }
	    {
	      button = gtk_button_new_with_label(_("Options"));
	      gtk_signal_connect(GTK_OBJECT(button), "clicked",
		  GTK_SIGNAL_FUNC(option_dialog), NULL);
	      gtk_box_pack_start(GTK_BOX(framevbox), button, FALSE, TRUE, 0);
	      gtk_widget_show(button);
	    }
	    {
	      button = gtk_button_new_with_label(_("Pass"));
	      gtk_signal_connect(GTK_OBJECT(button), "clicked",
		  GTK_SIGNAL_FUNC(bdk_pass), NULL);
	      gtk_box_pack_start(GTK_BOX(framevbox), button, FALSE, TRUE, 0);
	      gtk_widget_show(button);
	    }
	    {
	      button = gtk_button_new_with_label(_("Undo"));
	      gtk_signal_connect(GTK_OBJECT(button), "clicked",
		  GTK_SIGNAL_FUNC(bdk_back), NULL);
	      gtk_box_pack_start(GTK_BOX(framevbox), button, FALSE, TRUE, 0);
	      gtk_widget_show(button);
	    }
	    {
	      button = gtk_button_new_with_label(_("Next"));
	      gtk_signal_connect(GTK_OBJECT(button), "clicked",
		  GTK_SIGNAL_FUNC(bdk_next_move), NULL);
	      gtk_box_pack_start(GTK_BOX(framevbox), button, FALSE, TRUE, 0);
	      gtk_widget_show(button);
	    }
	    {
	      button = gtk_button_new_with_label(_("Hint"));
	      gtk_signal_connect(GTK_OBJECT(button), "clicked",
		  GTK_SIGNAL_FUNC(bdk_hint), NULL);
	      gtk_box_pack_start(GTK_BOX(framevbox), button, FALSE, TRUE, 0);
	      gtk_widget_show(button);
	    }
	    hhbox = gtk_hbox_new(FALSE, 0);
	    gtk_box_pack_start(GTK_BOX(framevbox), hhbox, TRUE, TRUE, 0);

	    dmode_label = gtk_label_new(_("Mode: "));
	    gtk_box_pack_start(GTK_BOX(hhbox), dmode_label, FALSE, TRUE, 0);
	    gtk_widget_show(dmode_label);
	    
	    {
	      optionmenu = gtk_option_menu_new();
	      gtk_option_menu_set_menu(GTK_OPTION_MENU(optionmenu),
		  create_mode_menu());
	      gtk_option_menu_set_history(GTK_OPTION_MENU(optionmenu), 0);
	      gtk_box_pack_start(GTK_BOX(hhbox), optionmenu, FALSE, TRUE, 0);
	      gtk_widget_show(optionmenu);
	    }
	    
	    gtk_widget_show(hhbox);
	    
	    {
	      button = gtk_button_new_with_label(_("Quit"));
	      gtk_signal_connect(GTK_OBJECT(button), "clicked",
		  GTK_SIGNAL_FUNC(bdk_quit), window);
	      gtk_box_pack_start(GTK_BOX(framevbox), button, FALSE, TRUE, 0);
	      gtk_widget_show(button);
	    }

	    gtk_widget_show(framevbox);
	  }
	  gtk_widget_show(frame);
	}

	gtk_widget_show(vvbox);
      }
      gtk_widget_show(hbox);
    }

    {
      statusbar = gtk_statusbar_new();
      gtk_box_pack_start(GTK_BOX(vbox), statusbar, FALSE, TRUE, 0);
      gtk_widget_show(statusbar);
    }

    gtk_widget_show(vbox);
  }
  gtk_widget_show(window);
  bdk_init();

  if (mode == RUN_LOAD_SGF) {
    load_sgf(fname, break_at);
  } else {
    show_baduki_logo();
  }

  gtk_main();

  return 0;
}

static void exit_callback(void)
{
  if (bdk_debug) {
    bdk_debug_next = TRUE;
    bdk_debug = FALSE;
    return;
  }
  
  gtk_main_quit();
}

void show_message(const gchar *buf)
{
  static guint message_id2 = 0;

  if (message_id2 > 0)
    gtk_statusbar_remove(GTK_STATUSBAR(statusbar), 1, message_id2);

  message_id2 = gtk_statusbar_push(GTK_STATUSBAR(statusbar), 1, buf);
}

char *get_coord(int x, int y)
{
  static char coord[20];

  sprintf(coord, "%c,%2d", (x < 8 ? x + 'A' : x + 'B'), y + 1);

  return coord;
}

static void clicked_callback(GtkGoBoard * go_board, gint x, gint y, gpointer data)
{
  guint stone, markup;

  if (bdk_debug)
    return;
  
  stone = gtk_go_board_get_stone(go_board, x, y);
  markup = gtk_go_board_get_markup(go_board, x, y);

  if (!ingame && counting) {
    bdk_mark_death_stone(x - 1, y - 1);
    return;
  }
  if (!ingame && !counting)
    return;

  if (!bdk_place_stone(current_turn, x - 1, y - 1))
    return;

  if (player_type[NEXT_TURN] == TYPE_GMP)
    gmp_sendMove(gmpp, x - 1, 19 - y);

  if (last_x[current_turn] != 0)
    gtk_go_board_set_mark(go_board, last_x[current_turn],
	last_y[current_turn], 0);
  last_x[current_turn] = x;
  last_y[current_turn] = y;
/*  gtk_go_board_set_stone(go_board, x, y,
   current_turn == BLACK ? GTK_GO_BOARD_SOLID_BLACK :
   GTK_GO_BOARD_SOLID_WHITE); */
  gtk_go_board_set_mark(go_board, x, y, GTK_GO_BOARD_TR_MASK);

  pass_count = 0;
  intrMoveReport(current_turn, get_coord(x - 1, y - 1), "");

  update_turn();
}

static void pressed_callback(GtkGoBoard * go_board, gint x, gint y, gint bt, gpointer data)
{
  static int old_showTrees;
  static int dx, dy, dd;
  int check_safe;
  char buf[80];
  
  if (bdk_debug) {
    bdk_debug_next = TRUE;
    return;
  }
  
  if (bt == 1)
    return;

  if (stringIDs[x - 1][y - 1] == 0) {
    if (bt == 2)
      check_safe = TRUE;
    else
      return;
  } else
    check_safe = FALSE;
    
  bdk_debug = TRUE;
  old_showTrees = showTrees;
  showTrees = TRUE;
  bdk_debug_next = FALSE;

  if (check_safe) {
    tryPlay(x-1,y-1, 1);
    dd = killable(x-1, y-1, &dx, &dy);
    restoreState();
  } else if (bt == 3)
    dd = killable(x - 1, y - 1, &dx, &dy);
  else
    dd = saveable(x - 1, y - 1, &dx, &dy);

  if (dd) {
    sprintf(buf, "-- %d: %s --", dd, get_coord(dx, dy));
    show_message(buf);
  } else
    show_message("----");

  showTrees = old_showTrees;
  bdk_debug = FALSE;
}

static void released_callback(GtkGoBoard * go_board, gint x, gint y, gint bt, gpointer data)
{
}


static void enter_callback(GtkGoBoard * go_board, gint x, gint y, gpointer data)
{
  extern struct moveseqtype move_seq[];
  guint state;
  int i = 0;

  if (!ingame && !counting)
    return;

  if (dmode[display_mode].mode == DMODE_GROUP) {
    i = GIDMap[x-1][y-1];
    sprintf(message_group, "%3d: str %d ext %d eye %d tr1 %d tr2 %d score %d stone %d string %d",
    	i, gList[i].strength, gList[i].exts, gList[i].eyes, gList[i].tr1,
    	gList[i].tr2, gList[i].score, gList[i].stones, gList[i].strings);
  } else if (dmode[display_mode].mode == DMODE_WGROUP) {
    i = wGIDMap[x-1][y-1];
    sprintf(message_group, "%3d: str %d ext %d eye %d tr1 %d tr2 %d score %d stone %d string %d",
    	i, wgList[i].strength, wgList[i].exts, wgList[i].eyes, wgList[i].tr1, 
    	wgList[i].tr2, wgList[i].score, wgList[i].stones, wgList[i].strings);
  } else if (dmode[display_mode].mode == DMODE_VEYE) {
    i = vEyeMap[x-1][y-1];
    sprintf(message_group, "%3d: mark %d eyes %d score %d mX %d MX %d mY %d MY %d",
    	i, vsgList[i].mark, vsgList[i].eyes, vsgList[i].score, vsgList[i].min_x,
    	vsgList[i].max_x, vsgList[i].min_y, vsgList[i].max_y);
  } else if (dmode[display_mode].mode == DMODE_BORD) {
    sprintf(message_group, "Extend.. L:%d, R:%d, U:%d, D:%d",
    	extMap[0][x-1][y-1], extMap[1][x-1][y-1], extMap[2][x-1][y-1],
    	extMap[3][x-1][y-1]);
  } else {
    i = SMap[stringIDs[x - 1][y - 1]];
    if (i)
      sprintf(message_group, "%3d: Mark %d Live %d Safe %d Dead %d libC %d Eyes %d size %d lx %d ly %d kc %d sc %d",
	  i, sList[i].stringMark,
	  sList[i].isLive, sList[i].isSafe, sList[i].isDead, sList[i].libC,
	  sList[i].numEyes, sList[i].size, sList[i].lx, sList[i].ly,
	  sList[i].kc, sList[i].sc);
    if (i == 0) {
      if (valueBoard[x-1][y-1] > 0)
        sprintf(message_group, "(%c, %d, %.1f)", 
          (x < 9 ? 'A' + x - 1 : 'B' + x - 1), y, (float) valueBoard[x-1][y-1] / 10);
      else
        sprintf(message_group, "(%c, %d)", 
        	(x < 9 ? 'A' + x - 1 : 'B' + x - 1), y);

      if (show_altmoves) {
	for (i = 0; altmoves[i].px; i++)
	  if (altmoves[i].px == x && altmoves[i].py == y) {
	    sprintf(message_group, "%s (%.1f,%d)%s", message_group,
		altmoves[i].value, altmoves[i].target,
		_(move_seq[altmoves[i].why].why));
	  }
      }
    }
  }

  if (player_type[current_turn] != TYPE_HUMAN)
    return;

  message_id = gtk_statusbar_push(GTK_STATUSBAR(statusbar), 1, message_group);

  state = gtk_go_board_get_stone(go_board, x, y);

  if (state == GTK_GO_BOARD_EMPTY) {
    if (current_turn == BLACK)
      gtk_go_board_set_stone(go_board, x, y,
	  GTK_GO_BOARD_TRANS_BLACK);
    else
      gtk_go_board_set_stone(go_board, x, y,
	  GTK_GO_BOARD_TRANS_WHITE);
  }
}

static void leave_callback(GtkGoBoard * go_board, gint x, gint y, gpointer data)
{
  guint state;

  if (!ingame && !counting)
    return;

  if (message_id > 0)
    gtk_statusbar_remove(GTK_STATUSBAR(statusbar), 1, message_id);

  state = gtk_go_board_get_stone(go_board, x, y);

  if (state == GTK_GO_BOARD_TRANS_BLACK
      || state == GTK_GO_BOARD_TRANS_WHITE) {
    gtk_go_board_set_stone(go_board, x, y, GTK_GO_BOARD_EMPTY);
  }
}

void show_time(int color, guint32 time)
{
  static char buf[80];
  
  sprintf(buf, _("Time: %d:%02d:%02d"), time / 3600,
  	(time % 3600) / 60, time % 60);

  gtk_label_set(GTK_LABEL(time_label[color]), buf);
}

guint show_ftime()
{
  guint32 dtime;

  if (!ingame) {
/*    gtk_timeout_remove(timer_id); */
    return FALSE;
  }
/*
  timer[current_turn]++;
  if (timer[current_turn] % 10 == 0) {
    sprintf(buf, "ð: %d:%02d:%02d", timer[current_turn] / 36000,
	(timer[current_turn] % 36000) / 600,
	(timer[current_turn] % 600) / 10);
    gtk_label_set(GTK_LABEL(time_label[current_turn]), buf);
  } */
    
  dtime = (timer[current_turn] + 
	(gdk_time_get() - turn_begin_time[current_turn]));

  if ((dtime / 1000) != (ftimer[current_turn] / 1000)) {
    ftimer[current_turn] = dtime;
    show_time(current_turn, dtime / 1000);
  }
  return TRUE;
}

void update_timer(int color, guint32 time)
{
  timer[color] += time;
  show_time(color, timer[color] / 1000);
}

void bdk_new_game(GtkWidget * widget, gpointer data)
{
  current_handicap = new_handicap;
/*  play_level = new_level; */
  pass_count = 0;
  ingame = TRUE;

  last_x[BLACK] = last_y[BLACK] = last_x[WHITE] = last_y[WHITE] = 0;

  gtk_go_board_clear_board(go_board);
  restart_baduk(current_handicap);

  timer[BLACK] = timer[WHITE] = 0;
  ftimer[BLACK] = ftimer[WHITE] = 0;

  if (current_handicap > 1)
    current_turn = WHITE;
  else
    current_turn = BLACK;

  if (current_handicap == 0)
    dum = 5.5;
  else
    dum = 0.5;

  if (player_type[BLACK] == TYPE_GMP ||
  	player_type[WHITE] == TYPE_GMP) {
    if (!bdk_gmp_init()) {
      show_message_box(_("Can't start a new game.\n"));
      ingame = FALSE;
      return;
    }
  }

  if (timer_id == 0)
    timer_id = gtk_timeout_add(100, (GtkFunction) show_ftime, NULL);

  turn_begin_time[BLACK] = turn_begin_time[WHITE] = gdk_time_get();
  
  gtk_frame_set_shadow_type(GTK_FRAME(p_frame[current_turn]),
  	GTK_SHADOW_ETCHED_OUT);

  if (player_type[current_turn] == TYPE_BADUKI)
    baduki_think();
  else if (player_type[current_turn] == TYPE_GMP)
    bdk_gmp_move();
}

void bdk_pass(GtkWidget * widget, gpointer data)
{
  extern void CountUp();

  if (!ingame) {
    if (counting) {
      CountUp();
      counting = 0;
    }
    return;
  }
  intrMoveReport(current_turn, _("Pass"), "");
  pass_count++;
  if (last_x[current_turn] != 0)
    gtk_go_board_set_mark(go_board, last_x[current_turn],
	last_y[current_turn], 0);
  bdk_place_stone(current_turn, -1, -1);
  last_x[current_turn] = 0;
  last_y[current_turn] = 0;
  if (player_type[NEXT_TURN] == TYPE_GMP)
    gmp_sendPass(gmpp);
  if (!CheckPasses())
    update_turn();
}

void bdk_back(GtkWidget * widget, gpointer data)
{
  if (!ingame)
    return;

  UndoLastMove();
}

void bdk_next_move(GtkWidget * widget, gpointer data)
{
  if (!ingame || max_move <= current_move)
    return;

  RedoNextMove();
}

void bdk_score(GtkWidget * widget, gpointer data)
{
  show_message(_("Scoring.."));
}

void bdk_quit(GtkWidget * widget, GtkWidget * window)
{
  if (bdk_debug) {
    bdk_debug_next = TRUE;
    bdk_debug = FALSE;
    return;
  }

  gtk_widget_destroy(window);
  gtk_main_quit();
}

void bdk_set_handicap(GtkWidget * widget, gpointer data)
{
  new_handicap = GPOINTER_TO_INT(data);
}

void bdk_set_playlevel(GtkWidget * widget, gpointer data)
{
  playLevel = GPOINTER_TO_INT(data) + 1;
}

void bdk_set_display_mode(GtkWidget * widget, gpointer data)
{
  if (display_mode == GPOINTER_TO_INT(data))
    return;
  
  display_mode = GPOINTER_TO_INT(data);
  
  show_labels();
}

void set_gmp_player(int pn)
{
  char buf[1024];
  struct termios  newTty;
  
  if (gmp_in >= 0) {
    close(gmp_in);
    close(gmp_out);
    gmp_in = -1;
    gmp_out = -1;
  }
  gmp_in = gmp_out = open(player_name[pn], O_RDWR | O_NDELAY);
  if (gmp_in < 0) {
    sprintf(buf, "SET_GMP_PLAYER\n%s\n", strerror(errno));
    show_message_box(buf);
    player_type[pn] = TYPE_HUMAN;
  } else if (isatty(gmp_in)) {
    newTty.c_cflag = B2400 | CREAD | CLOCAL | CS8;
    newTty.c_iflag = 0;
    newTty.c_oflag = 0;
    newTty.c_lflag = 0;
    bzero(newTty.c_cc, NCCS);
    tcsetattr(gmp_in, TCSANOW, &newTty);
  }
}

void bdk_set_white_type(GtkWidget * widget, gpointer data)
{
  player_type[WHITE] = GPOINTER_TO_INT(data);
  if (player_type[WHITE] == TYPE_GMP) {
    if (player_type[BLACK] == TYPE_GMP)
      player_type[BLACK] = TYPE_HUMAN;
    else
      set_gmp_player(WHITE);
  }
}

void bdk_set_black_type(GtkWidget * widget, gpointer data)
{
  player_type[BLACK] = GPOINTER_TO_INT(data);
  if (player_type[BLACK] == TYPE_GMP) {
    if (player_type[WHITE] == TYPE_GMP)
      player_type[WHITE] = TYPE_HUMAN;
    else
      set_gmp_player(BLACK);
  }
}

void show_moveinfo()
{
  char buf[80];

  sprintf(buf, _("Move : %d/%d, %s to play"), current_move, max_move, COLOR_NAME(current_turn));

  gtk_label_set(GTK_LABEL(info_label), buf);
}

void update_turn(void)
{
  guint32 current_time;
/*  char buf[80]; */
  
  if (!ingame)
    return;

  current_time = gdk_time_get();
  gtk_frame_set_shadow_type(GTK_FRAME(p_frame[current_turn]),
  	GTK_SHADOW_ETCHED_IN);
  update_timer(current_turn, (current_time - turn_begin_time[current_turn]));

  current_turn = current_turn == BLACK ? WHITE : BLACK;
  turn_begin_time[current_turn] = current_time;
  ftimer[current_turn] = timer[current_turn];
  
  gtk_frame_set_shadow_type(GTK_FRAME(p_frame[current_turn]),
  	GTK_SHADOW_ETCHED_OUT);
  
  save_current_to_sgf();
  if (message_id > 0)
    gtk_statusbar_remove(GTK_STATUSBAR(statusbar), 1, message_id);

/*  sprintf(buf, _("Move : %d/%d, %s to play"), current_move, max_move, COLOR_NAME(current_turn));

  gtk_label_set(GTK_LABEL(info_label), buf); */
  show_moveinfo();
/*  show_message("%s  :", COLOR_NAME(current_turn)); */

  if (player_type[current_turn] == TYPE_BADUKI)
    baduki_think();
  else if (player_type[current_turn] == TYPE_GMP)
    bdk_gmp_move();
}

int CheckPasses(void)
{
  if (pass_count >= MAX_PASSES) {
    show_message(_("Mark death stones and press PASS."));
    ingame = 0;
    counting = 1;
    save_current_to_sgf();
    return TRUE;
  } else
    return FALSE;
}

void clear_all_mark()
{
  int i, j;
  
  for (i = 1; i <= 19; i++)
    for (j = 1; j <= 19; j++)
      gtk_go_board_set_mark(go_board, i, j, 0);
}

void baduki_think(void)
{
  int x, y;
  
  show_message(_("Thinking..."));

  if (dmode[display_mode].mode == DMODE_PLAY)
    for (x = 1; x <= 19; x++)
      for (y = 1; y <= 19; y++)
        gtk_go_board_set_label(go_board, x, y, "");

  while (gtk_events_pending())
	gtk_main_iteration();

  if (genMove(current_turn, &x, &y)) {
    pass_count = 0;
/*    clear_all_mark(); */
    bdk_place_stone(current_turn, x, y);
    if (player_type[NEXT_TURN] == TYPE_GMP)
      gmp_sendMove(gmpp, x, 18 - y);
    if (last_x[current_turn] != 0)
      gtk_go_board_set_mark(go_board, last_x[current_turn],
	  last_y[current_turn], 0);
    last_x[current_turn] = x + 1;
    last_y[current_turn] = y + 1;
/*    gtk_go_board_set_stone(go_board, x + 1, y + 1,
   current_turn == BLACK ? GTK_GO_BOARD_SOLID_BLACK :
   GTK_GO_BOARD_SOLID_WHITE); */
/*    for (i = 0; altmoves[i].px; i++) {
        gtk_go_board_set_mark(go_board, altmoves[i].px, altmoves[i].py,
   GTK_GO_BOARD_SQ_MASK);
	if (!gtk_go_board_get_label(go_board, altmoves[i].px, altmoves[i].py) ||
	    atoi(gtk_go_board_get_label(go_board, altmoves[i].px, altmoves[i].py)) <
	    altmoves[i].value) {
	  sprintf(buf, "%.1f", altmoves[i].value);
	  gtk_go_board_set_label(go_board, altmoves[i].px, altmoves[i].py,
	      buf);
	}
      }
*/
    gtk_go_board_set_mark(go_board, x + 1, y + 1, GTK_GO_BOARD_TR_MASK);
    intrMoveReport(current_turn, get_coord(x, y), _(playReason));
    if (show_altmoves || display_mode) {
/* genBord ϸ   ξ  ° ǥõȴ */
/*      genBord(current_turn); */
      show_labels();
    }
    update_turn();
  } else {
    if (last_x[current_turn] != 0)
      gtk_go_board_set_mark(go_board, last_x[current_turn],
	  last_y[current_turn], 0);
    bdk_place_stone(current_turn, -1, -1);
    pass_count++;
    last_x[current_turn] = 0;
    last_y[current_turn] = 0;
    intrMoveReport(current_turn, _("Pass"), "");
    if (player_type[NEXT_TURN] == TYPE_GMP)
      gmp_sendPass(gmpp);

    if (!CheckPasses())
      update_turn();
  }
}

void bdk_hint(GtkWidget * widget, gpointer data)
{
  int x, y;
  char buf[80];
  
  if (!ingame)
    return;

  show_message(_("Thinking..."));

  while (gtk_events_pending())
	gtk_main_iteration();

  if (dmode[display_mode].mode == DMODE_PLAY)
    for (x = 1; x <= 19; x++)
      for (y = 1; y <= 19; y++)
        gtk_go_board_set_label(go_board, x, y, "");

  if (genMove(current_turn, &x, &y)) {
    pass_count = 0;
    sprintf(buf, "(%s) %s", get_coord(x, y), _(playReason));
    show_message(buf);
    show_labels();
/*    gtk_go_board_set_mark(go_board, x + 1, y + 1, GTK_GO_BOARD_TR_MASK); */
  } else {
    show_message(_("Pass"));
  }
}

int bdk_gmp_wait(Gmp * ge)
{
  GmpResult result;
  const char *err;
  char buf[1024];

  show_message(_("Connecting..."));
  do {
    while (gtk_events_pending())
	gtk_main_iteration();
    result = gmp_check(ge, 1, NULL, NULL, &err);
  } while (/*player_type[current_turn] == TYPE_GMP && */
  	((result == gmp_nothing) || (result == gmp_reset)));
  if (result == gmp_err) {
    sprintf(buf, "GMP_WAIT\n%s\n%s\n", strerror(errno), err);
    show_message_box(buf);
    return FALSE;
  } else if (result != gmp_newGame) {
    sprintf(buf, "GMP_WAIT\nExpecting a newGame, got %s\n",
	gmp_resultString(result));
    show_message_box(buf);
    return FALSE;
  }
  show_message(_("Success!"));
  return TRUE;
}

int bdk_gmp_init()
{
  int iamWhite;
/*  extern int gmp_debug;
  
  gmp_debug = 1; */

  if (gmp_in < 0) {
    if (player_type[BLACK] == TYPE_GMP)
      set_gmp_player(BLACK);
    if (player_type[WHITE] == TYPE_GMP)
      set_gmp_player(WHITE);
  }
  gmpp = gmp_create(gmp_in, gmp_out);
  
 /* void  gmp_startGame(Gmp *ge, int size, int handicap, float komi,
		    int chineseRules, int iAmWhite) */

  if (player_type[WHITE] == TYPE_GMP)
    iamWhite = FALSE;
  else
    iamWhite = TRUE;
    
/*  gmp_startGame(gmpp, -1, -1, 5.5, -1, -1);  */
  gmp_startGame(gmpp, 19, current_handicap, dum, 0, iamWhite);
/*  gmp_startGame(gmpp, 19, current_handicap, dum, 0, gmp_is_white); */
  
  return bdk_gmp_wait(gmpp);
}

int bdk_gmp_move()
{
  int gx, gy, x, y;
  char buf[1024];
  GmpResult gmp_message;
  const char *gmp_error;

  if (player_type[current_turn] != TYPE_GMP)
    return FALSE;

  show_message(_("Waiting...."));
  do {
    while (gtk_events_pending())
	gtk_main_iteration();
    gmp_message = gmp_check(gmpp, 1, &gx, &gy, &gmp_error);
    x = gx;
    y = 18 - gy;
  } while (gmp_message == gmp_nothing && player_type[current_turn] == TYPE_GMP);

  show_message(_("Analyzing GMP signal..."));
  if (gmp_message == gmp_err) {
    sprintf(buf, "Got gmp_error \"%s\"\n", gmp_error);
    show_message_box(buf);
    return FALSE;
  }
  if (gmp_message == gmp_move) {
    if (!bdk_place_stone(current_turn, x, y)) {
      sprintf(buf, "Invalid Position %d %d\n", x, y);
      show_message_box(buf);
      return FALSE;
    }
    if (last_x[current_turn] != 0)
      gtk_go_board_set_mark(go_board, last_x[current_turn],
	  last_y[current_turn], 0);
    last_x[current_turn] = x + 1;
    last_y[current_turn] = y + 1;
    gtk_go_board_set_mark(go_board, x + 1, y + 1, GTK_GO_BOARD_TR_MASK);

    pass_count = 0;
    intrMoveReport(current_turn, get_coord(x, y), "");

    update_turn();
  } else if (gmp_message == gmp_pass) {
    if (!ingame) {
      show_message_box("GMP_PASS, But game is over!");
      return FALSE;
    }
    intrMoveReport(current_turn, _("Pass"), "");
    pass_count++;
    if (last_x[current_turn] != 0)
      gtk_go_board_set_mark(go_board, last_x[current_turn],
	  last_y[current_turn], 0);
    bdk_place_stone(current_turn, -1, -1);
    last_x[current_turn] = 0;
    last_y[current_turn] = 0;
    if (!CheckPasses())
      update_turn();

  } else if (gmp_message == gmp_reset) {
    /* Game over! */
    return FALSE;
  } else if (gmp_message == gmp_undo) {
    sprintf(buf, "GMP_PASS\nI am asked to undo %d moves.\n", x);
    show_message_box(buf);
    return FALSE;
  } else {
    sprintf(buf, "GMP_ERROR\nGot a \"%s\" command during game play.\n",
	gmp_resultString(gmp_message));
    return FALSE;
  }

  return TRUE;
}
