/* Baduki - Computer Baduk(Go) Program 
   Copyright(c) 1998-1999 Lim Jaebum <artist@soback.kornet21.net>

   This program is free software; you can redistribute it and'or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
   USA */

/* $Id: xinterface.c,v 1.7 1999/02/06 12:52:55 artist Exp $ */ 

#include <config.h>
#include "intldefs.h"

#include <stdio.h>
#include <gtk/gtk.h>

#include "gtkgoboard.h"
#include "baduki.h"

extern GtkGoBoard *go_board;
extern GtkLabel *time_label[2], *score_label[2], *position_label[2];

extern int showTrees, playLevel, showMoveReason, stringInfo;
extern char *playReason;

extern int gmp_mode;

/* Print a stone of color at x, y intersection */
void placestone(color, x, y)
     enum bVal color;
     int x, y;
{
  if (gmp_mode)
    return;

  gtk_go_board_set_stone(go_board, x + 1, y + 1,
	color == BLACK ? GTK_GO_BOARD_SOLID_BLACK :
	GTK_GO_BOARD_SOLID_WHITE);
}

/* Remove a stone from an intersection */
void removestone(x, y)
     int x, y;
{
  if (gmp_mode)
    return;

  gtk_go_board_set_stone (go_board, ++x, ++y, GTK_GO_BOARD_EMPTY);
}

/* Report on a move */
void intrMoveReport(color, coord, reason)
     enum bVal color;
     char *coord;
     char *reason;
{
  char buf[80];
  
  if (gmp_mode)
    return;
  
  sprintf(buf, _("Last Move: %s"), coord);  
  gtk_label_set(position_label[color], buf);
  
  show_message(reason);

/*  XtVaSetValues(message, XtNstring, "", NULL);

  XtVaSetValues((color == BLACK ? black_stat_widgets[4] :
	  white_stat_widgets[4]), XtNlabel, coord, 0);

  XtVaSetValues(message, XtNstring, (showMoveReason ? reason : ""), NULL); */
}

void reportReason()
{
  if (gmp_mode)
    return;
    
  show_message(playReason);
}

void intrPrisonerReport(blackcnt, whitecnt)
     int blackcnt;
     int whitecnt;
{
  extern int current_score[], Prisoners[];
  char buf[80];
  
  if (gmp_mode)
    return;

  sprintf(buf, _("Capture: %2d, Score: %2d"), Prisoners[BLACK], current_score[WHITE]);
  gtk_label_set(score_label[WHITE], buf);
  
  sprintf(buf, _("Capture: %2d, Score: %2d"), Prisoners[WHITE], current_score[BLACK]);
  gtk_label_set(score_label[BLACK], buf);
}

void show_message_box(gchar *message)
{
  GtkWidget *dialog, *label, *button;

  dialog = gtk_dialog_new();
  gtk_window_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
  gtk_container_border_width (GTK_CONTAINER (dialog), 5);

  label = gtk_label_new(message);
  gtk_misc_set_padding(GTK_MISC(label), 20, 20);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), label, TRUE, TRUE, 0);
  gtk_widget_show(label);

  button = gtk_button_new_with_label(_("OK"));
  gtk_widget_set_usize(button, 80, -1);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area), button, FALSE,
                     FALSE, 14);
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  gtk_widget_grab_default (button);
  gtk_widget_show(button);

  gtk_signal_connect_object (GTK_OBJECT (dialog), "delete_event",
                             GTK_SIGNAL_FUNC(gtk_widget_destroy),
                             GTK_OBJECT (dialog));
  gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
                             GTK_SIGNAL_FUNC(gtk_widget_destroy),
                             GTK_OBJECT (dialog));
  gtk_widget_show(dialog);
}
